// board: Seeed XIAO
// all sensors work DS18B20 - BME280  - Lux
// last test 25-sep-2024
// used example from Martyn Currey 
#include <ArduinoBLE.h>                      // BLE
#define MAXIMWIRE_EXTERNAL_PULLUP            // DS18B20  USE MAXIMUMWIRE is0 ONEWIRE
#include <MaximWire.h>                       // DS18B20
#define PIN_BUS D9                           // DS18B20
MaximWire::Bus bus(PIN_BUS);                 // DS18B20
MaximWire::DS18B20 device;                   // DS18B20
  
#include <Wire.h>                            // Adafruit_BME280
#include <Adafruit_Sensor.h>                 // BME280
#include <Adafruit_BME280.h>
Adafruit_BME280 bme;                         // I2C   address 0x76
unsigned long delayTime;
// Variables used for incoming data
const byte maxDataLength = 20;
char receivedChars[21] ;          
boolean newData = false;
const byte SWITCH_PIN[] = {D1,D2,D3};
const byte LED_PIN[] = {D6,D7,D8};
//const byte PIR_PIN = D10;
// general variables
boolean LED_State[] = {false,false,false};
boolean switch_State[] = {false,false,false};
boolean oldswitch_State[] = {false,false,false};

int sensorLDR;                                // A1 input pin reads the lightconditions with an LDR
unsigned long startMillis;                    //some global variables available anywhere in the program
unsigned long currentMillis;
const unsigned long sensorInterval = 4000;   // 10 sec sensor meetinterval
//BLEService Tuinhuis("00002A00-0000-1000-8000-00805F9B34FB");             // nieuw 8 oct                        // ServiceUUID2
BLEService TuinhuisControl("19B10010-E8F2-537E-4F6C-D104768A1214");                                            // ServiceUUID
BLEByteCharacteristic relaisBinnen("19B10011-E8F2-537E-4F6C-D104768A1214", BLERead | BLEWrite | BLENotify );                 // int expects 32 bit 
BLEByteCharacteristic relaisBuiten("19B10012-E8F2-537E-4F6C-D104768A1214", BLERead | BLEWrite | BLENotify );                 // CharUUID2
BLEByteCharacteristic relaisVerwarming("19B10013-E8F2-537E-4F6C-D104768A1214",  BLERead | BLEWrite | BLENotify );            // CharUUID3
BLEByteCharacteristic switchStateBinnen("19B10014-E8F2-537E-4F6C-D104768A1214", BLERead | BLEWrite );                // CharUUID4
BLEByteCharacteristic switchStateBuiten("19B10015-E8F2-537E-4F6C-D104768A1214", BLERead | BLEWrite );                // CharUUID5
BLEByteCharacteristic switchStateVerwarming("19B10016-E8F2-537E-4F6C-D104768A1214", BLERead | BLEWrite | BLENotify); // CharUUID6
BLEFloatCharacteristic DS18B20("19B10017-E8F2-537E-4F6C-D104768A1214", BLERead | BLEWrite | BLENotify);
BLEFloatCharacteristic BMETemp("19B10018-E8F2-537E-4F6C-D104768A1214", BLERead | BLENotify);   
BLEShortCharacteristic BMEHum("19B10019-E8F2-537E-4F6C-D104768A1214", BLERead | BLEWrite);     // 2A6F Humidity Unsigned integer Uint16  
BLEShortCharacteristic BMEHpa("19B1001A-E8F2-537E-4F6C-D104768A1214", BLERead | BLEWrite);    // 2A6D Pressure Unsigned integer Uint32                                                             // CharUUID9
BLEShortCharacteristic LUX("19B1001B-E8F2-537E-4F6C-D104768A1214", BLERead | BLEWrite);        // 2A77 Irradiance Unsigned integer Uint16", BLERead );        // 2A77 Irradiance Unsigned integer Uint16
BLEByteCharacteristic PIR("19B1001C-E8F2-537E-4F6C-D104768A1214", BLERead | BLEWrite | BLENotify);  
float tempDS18B20;
float tempBME;
short humBME;
short HpaBME;
short lux;
byte PIRalarm;

void setup()  
{
    //sensors.begin();                // new DS18B20
    delay(1000);                    // new
    Serial.begin(9600);
    delay(2000);
    Serial.println("entering setup ");    // tekst ok
    for (byte pin = 0; pin < 3; pin++) 
    {
         // Set the button switch pins for input
         pinMode(SWITCH_PIN[pin], INPUT); 
         
         // Set the LED pins for output and make them LOW
         pinMode(LED_PIN[pin], OUTPUT);  digitalWrite(LED_PIN[pin],LOW);
    } 
     
    //pinMode(PIR_PIN, INPUT);
    bool status;
    status = bme.begin(0x76);  
    if (!status) {
     Serial.println("Could not find a valid BME280 sensor, check wiring!");
     while (1);
      Serial.println("I2C seems ok");       // deze tekst zie ik niet  
    }
   delay(1000); 
   newData = false;
   startMillis = millis();  //initial start time
   BLE.begin();
   BLE.setLocalName("Tuinhuis CB-MS");
   BLE.setDeviceName("Seeed_nRF52840");
   //BLE.setAdvertisedService(Tuinhuis);                // nieuw 8 oct
   BLE.setAdvertisedService(TuinhuisControl);
   TuinhuisControl.addCharacteristic(relaisBinnen);
   TuinhuisControl.addCharacteristic(relaisBuiten);
   TuinhuisControl.addCharacteristic(relaisVerwarming);
   TuinhuisControl.addCharacteristic(switchStateBinnen);
   TuinhuisControl.addCharacteristic(switchStateBuiten);
   TuinhuisControl.addCharacteristic(switchStateVerwarming);
   TuinhuisControl.addCharacteristic(DS18B20);
   TuinhuisControl.addCharacteristic(BMETemp);
   TuinhuisControl.addCharacteristic(BMEHum);
   TuinhuisControl.addCharacteristic(BMEHpa);
   TuinhuisControl.addCharacteristic(LUX);
   TuinhuisControl.addCharacteristic(PIR);
   //BLE.addService(Tuinhuis);                   // nieuw 8 oct // verwijderd 27 oct
   //BLE.addService(TuinhuisSensor);             // regel na addchar
   BLE.addService(TuinhuisControl); 
   relaisBinnen.writeValue(0);
   relaisBuiten.writeValue(0);
   relaisVerwarming.writeValue(0);
   switchStateBinnen.writeValue(0);
   switchStateBuiten.writeValue(0);
   switchStateVerwarming.writeValue(0);
   
   PIR.writeValue(0);
   BLE.advertise();
   Serial.println("advertising ...");
}

void TemperatureDS18B20(){
  if (device.IsValid()) {
        tempDS18B20 = device.GetTemperature<float>(bus); 
        if (!isnan(tempDS18B20)) {
            Serial.print("Temp DS18B20= "); Serial.println(tempDS18B20,1);
            device.Update(bus);
            //DS18B20.writeValue(round(temp*10/10.0));         
        } else {
            Serial.print("LOST ");
            Serial.println(device.ToString());
            device.Reset();
        }
    } else {
        if (bus.Discover().FindNextDevice(device) && device.GetModelCode() == MaximWire::DS18B20::MODEL_CODE) {
            Serial.print("FOUND ");
            Serial.println(device.ToString());
            device.Update(bus);
        } else {
            Serial.println("NOTHING FOUND");
            device.Reset();
        }
    }
    delay(10); 
}



void printValuesBME280() {
  Serial.print("TemperatureBME280 = ");
  //Serial.print(round(bme.readTemperature());
  tempBME = bme.readTemperature();
  //Serial.print(bme.readTemperature()-0.5,1);
  Serial.print(tempBME,1);
  Serial.println(" *C");
  
  Serial.print("PressureBME280 = ");
  HpaBME = int(bme.readPressure()/100);
  Serial.print(int(bme.readPressure()/100));
  //Serial.print(bme.readPressure() / 100.0F,0);
  Serial.println(" hPa");
   
  Serial.print("HumidityBME280 = ");
  humBME = int(bme.readHumidity());
  Serial.print(int(bme.readHumidity()));
  //Serial.print(bme.readHumidity(),0);
  Serial.println(" %");
  Serial.println();
  //BMETemp.writeValue(bme.readTemperature()-0.5,1);
  //BMEHum.writeValue(bme.readHumidity(),0);
  //BMETemp.writeValue(round(bme.readTemperature()*10)/10.0);
  //BMETemp.writeValue(temperature);
  

}

void Lichtmeten() {
  sensorLDR = analogRead(A0); 
  Serial.print("Lux = ");
  Serial.println(sensorLDR); 
  
}

void checkSwitch( byte pos)                       // switches on 
{
     // pos = 1,2,3. Array pos = 0,1,2 so convert by subtracting 1
     pos = pos-1;
     // very simple debouce.
     boolean state1 = digitalRead(SWITCH_PIN[pos]); delay(1);
     boolean state2 = digitalRead(SWITCH_PIN[pos]); delay(1);
     boolean state3 = digitalRead(SWITCH_PIN[pos]); delay(1);
     if ((state1 == state2) && (state1==state3))   
     { 
          switch_State[pos] = state1;  
          if ( (switch_State[pos] == HIGH) && (oldswitch_State[pos] == LOW) )
          {
               LED_State[pos] = ! LED_State[pos];  // flip the status.

               // Rather than have a long list of possible commands I create the command as required.
               // Values in the temp command are replaced depending on which button switch has been pressed.
               char TMPcmd[8] = "[L,1,0]";
               TMPcmd[3] = pos+1+48;             // pos+1 should be 1,2, or 3.   convert a numeric value to ascii by adding 48. 
               TMPcmd[5] = LED_State[pos]+48;    // LED_State should be 0 or 1
             
               digitalWrite(LED_PIN[pos],LED_State[pos]);  
               Serial.println(TMPcmd); 
               Serial.print("pos = "); Serial.println(pos);
              
          }          
          oldswitch_State[pos] = switch_State[pos];

      }
}


void processCommand() {
    
    //switchStateBinnen.readValue(switch_State[0]); Serial.print("switchStateBinnen = "); Serial.println(value);
    //switchStateBuiten.readValue(value); Serial.print("switchStateBuiten = "); Serial.println(value);
    //switchStateVerwarming.readValue(value); Serial.print("switchStateVerwarming = "); Serial.println(value);
    if (relaisBinnen.written()) { Serial.println("Binnen pressed");
      if (relaisBinnen.value()) { digitalWrite(D6, HIGH); relaisBinnen.writeValue(1);  } 
      else { digitalWrite(D6, LOW); relaisBinnen.writeValue(0); }
      } 
    else if (relaisBuiten.written()) { Serial.println("Buiten pressed");
      if (relaisBuiten.value()) { digitalWrite(D7, HIGH);  relaisBuiten.writeValue(1);  }
      else { digitalWrite(D7, LOW);  relaisBuiten.writeValue(0); }
      }  
    else if (relaisVerwarming.written()) { Serial.println("Verwarming pressed");
      if (relaisVerwarming.value()) { digitalWrite(D8, HIGH); relaisVerwarming.writeValue(1); }
      else { digitalWrite(D8, LOW); relaisVerwarming.writeValue(0); }
    }
}

 

void remaining()  {
  currentMillis = millis();
  if (currentMillis - startMillis >= sensorInterval)  {
     Lichtmeten();
     //THSensor();
     printValuesBME280();
     TemperatureDS18B20();
     Serial.println();
     startMillis = currentMillis;  //IMPORTANT to save the start time of the current LED state.
     }
}

void loop()  {     
  BLEDevice central = BLE.central();
  
  if (central) {  
    Serial.print("Connected to central  ");
    Serial.println(central.address()); 
    while (central.connected()) {
      for (byte switchNum = 1; switchNum < 4; switchNum++) 
      {
           checkSwitch(switchNum);
      }
      BLE.poll();
      LUX.writeValue(sensorLDR); //Serial.println("Lux written");
      BMETemp.writeValue(tempBME); 
      //BMEHum.writeValue(humBME);
      BMEHum.writeValue(99); 
      BMEHpa.writeValue(HpaBME); 
      //DS18B20.writeValue(round(tempDS18B20*10/10.0));
      DS18B20.writeValue(tempDS18B20); 
      processCommand(); 
      remaining();
      } 
    Serial.print(F("Disconnected from central: "));
    Serial.println(central.address());
    }
  long time = millis();
      for (byte switchNum = 1; switchNum < 4; switchNum++) 
      {
           checkSwitch(switchNum);
      }
  //processCommand(); 
  remaining();
  delay(1);
}

 
 
